package boundedmaxsum;

import graphManager.GraphManager;

public class DataGraphGenerator {
	
	private GraphManager gm;
	private String dir = "";
	
	DataGraphGenerator(int n, int nc, double avgcn){
		gm = new GraphManager(n, nc);
		gm.genConnectedGraph(avgcn);
	}
	
	public void setDir(String dir) {
		this.dir = dir;
	}
	
	public String getDir() {
		return dir;
	}
	
	private void save(String filename) {
		gm.writeGraph(dir+"/"+filename);	
	}
	
	public static void main(String[] args) {
		String dirName = "dataGraphs";
		int n = 10;
		int nc = 3;
		double avgconn = 2.;
		
		
		for (int i = 5; i <=50 ; i=i+5) {
			for (double c = 2.0; c<=3; c++){
				DataGraphGenerator dcg = new DataGraphGenerator(i,nc,c);
				dcg.setDir(dirName);
				dcg.save("gc3-"+i+"-"+c);
				System.out.println("avg connections = "+(double) dcg.gm.getNumberOfEdges()/dcg.gm.getNumberOfNodes());				
			}
		}
		
	}
	
}
