package coproblem;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import boundedmaxsum.Distribution;

public class ComputeAlpha {
	private static final int REPETITIONS = 25;

	public static void main(String[] args) {
		
		String dataFilePrefix = "/home/sandrof/dataGraphs/AdoptProblems/Problem-GraphColor-";
		Distribution[] distroList = {Distribution.GAMMA, Distribution.UNIFORM};
		
		
		int[] l = {8,10,12,14,16,18,20,25,30,40};
		//int[] l = {10};
		
		for (int c = 2;c<=3;c++){
			for (int j = 0; j < distroList.length; j++) {
				BufferedWriter msOut = null;
				try {
					msOut = new BufferedWriter(new FileWriter("beta-"+c+"-"+distroList[j], true));
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				for (int i = 0; i < l.length; i++) {
					for (int repetitions = 0; repetitions < REPETITIONS; repetitions++){
						String dataFile = dataFilePrefix + l[i]+"_3_"+c+"_0.4_r"+repetitions+"-"+distroList[j]+".COP";
						COProblem cp = COProblem.load(dataFile);
						double beta = cp.getBeta();
						double alpha = cp.getAlpha();
						try {
							msOut = new BufferedWriter(new FileWriter("beta-"+c+"-"+distroList[j], true));
							msOut.write(l[i]+"\t"+beta+"\t"+alpha+"\n");
							msOut.close();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}	

					}
				}
			}	
		}
	}
}
